---@diagnostic disable: redundant-parameter, undefined-doc-name
-- name: \\#4d0000\\ MX moveset v1.3
-- description: mod made by Dremy_Bowser  play as the scary guy himself!!!!  (thx Birdikek for his reduced knockback)

local movesetactive = false
local CT = gMarioStates[0].character.type

function mario_update (m)
-- disable fall damage
if m.character.type ~= CT_MARIO then return end
if not movesetactive then return end
m.peakHeight = m.pos.y
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

local can_press_x = 0

function x_pressed(m)
  if m.playerIndex ~= 0 then return end
  if m.character.type ~= CT_MARIO then return end -- WAHOOOOOOOOOOO!!!!
  if not movesetactive then return end
  if m.controller.buttonPressed & X_BUTTON ~= 0 then
      if x_press_counter > 0 then
          set_jumping_action(m, ACT_WALL_KICK_AIR, 0)
          x_press_counter = x_press_counter - 1
      end
  end

  if (m.action & ACT_FLAG_AIR) == 0 then
      x_press_counter = 3
  end
end
hook_event(HOOK_MARIO_UPDATE, x_pressed)

  
function y_pressed(m)
  if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    if m.controller.buttonDown & Y_BUTTON ~= 0 then
        mario_set_forward_vel(m, 85)  -- Innocence doesn't get you far...
    end
end

hook_event(HOOK_MARIO_UPDATE, y_pressed)


hook_chat_command("MX","85", function (msg)
    movesetactive = not movesetactive
    if msg == "on" then
        movesetactive = true
    elseif msg == "off" then
        movesetactive = false
    end
    djui_chat_message_create(movesetactive and "WAHOOOOOOOOOOO!!!" or "See you next time. . .")
        return true
end)

function mario_update(m)
  if m.character.type ~= CT_MARIO then return end
  if not movesetactive then return end
    if not gGlobalSyncTable.jumpboost then
      if m.prevAction == ACT_GROUND_POUND_LAND then
        set_mario_action(m, ACT_TRIPLE_JUMP, 0)
      end
  end
end
hook_event(HOOK_MARIO_UPDATE, mario_update)

-- Boss character BS --

function mario_update(m)
  if m.character.type ~= CT_MARIO then return end
  if not movesetactive then return end
    gPlayerSyncTable[i].Walk = true
  if type == STEP_TYPE_AIR and m.vel.y < 0 then
          ray = collision_find_surface_on_ray(m.pos.x, m.pos.y, m.pos.z, m.vel.x, m.vel.y, m.vel.z)
          if ray.surface ~= nil then
              if ray.surface.normal.y ~= 0 then
                  m.peakHeight = m.pos.y
              end
          end
      end
  end

hook_event(HOOK_ALLOW_HAZARD_SURFACE,    function (m) return not (m.character.type == CT_MARIO and movesetactive) end)

function mario_update (m)
  if m.character.type ~= CT_MARIO then return end
  if not movesetactive then return end
  if m.action == ACT_DOUBLE_JUMP then
    m.action = ACT_JUMP
end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

function mario_update(m)
  if m.character.type ~= CT_MARIO then return end
  if not movesetactive then return end
  if m.forwardVel >= 60 then
      m.flags = m.flags | MARIO_METAL_CAP
  else
      m.flags = m.flags & ~MARIO_METAL_CAP
  end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

function mario_update(m)
  if m.character.type ~= CT_MARIO then return end
  if not movesetactive then return end
if m.action == ACT_GROUND_POUND_LAND then
  set_camera_shake_from_hit(SHAKE_MED_DAMAGE)
end
end
hook_event(HOOK_MARIO_UPDATE, mario_update)

local timer = 0

function mario_update(m)
  if m.character.type ~= CT_MARIO then return end
  if not movesetactive then return end
    m = gMarioStates[0]
    if m.action == ACT_BACKWARD_AIR_KB or m.action == ACT_FORWARD_AIR_KB then
        local randomtime = math.random(80, 140) -- thank you Birdikek!!!!!!!!!
        timer = timer + 1
        if timer >= randomtime then
            set_mario_action(m, ACT_IDLE, 0)
        end
    else
        timer = 0
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

   
gStateExtras = {}
for i=0,(MAX_PLAYERS-1) do
    gStateExtras[i] = {}
    local m = gMarioStates[i]
    local e = gStateExtras[i]
end

gEventTable = {}

ACT_MARIO_PUNCH    = (0x05B | ACT_FLAG_MOVING | ACT_FLAG_ATTACKING) -- get back here!!!!
function act_mario_punch(m)
  if m.character.type ~= CT_MARIO then return end
  if not movesetactive then return end
    local e = gStateExtras[m.playerIndex]
	if m.actionTimer == 0 then
        m.actionState = m.actionArg
		play_sound(SOUND_MARIO_YAHOO, m.marioObj.header.gfx.cameraToObject)
    end
    common_slide_action(m, ACT_WALKING, ACT_FLAG_ATTACKING, MARIO_ANIM_FIRST_PUNCH)
    set_anim_to_frame(m, 25)
	m.slideVelX = m.slideVelX * 1.3
	m.slideVelZ = m.slideVelZ * 1.3
	update_sliding(m, -1)
    if m.actionTimer > 20 then
	   return set_mario_action(m, ACT_WALKING, 85)
	end
	if (m.input & INPUT_A_PRESSED) ~= 0 then
        return set_jumping_action(m, ACT_WALL_KICK_AIR, 0)
    end
	m.actionTimer = m.actionTimer + 1
	return 0
end
function mario_update(m)
  if m.character.type ~= CT_MARIO then return end
  if not movesetactive then return end
   local hScale = 1.0
   if (m.controller.buttonPressed & L_JPAD) ~= 0 and (m.action & ACT_FLAG_MOVING) ~= 0 then
      m.actionTimer = 0
      return set_mario_action(m, ACT_MARIO_PUNCH, 0)
   end
   if (m.action & ACT_FLAG_AIR) ~= 0 then
       m.vel.y = m.vel.y - 0.1
   end
   if (m.action & ACT_FLAG_MOVING) ~= 0 then
       hScale = hScale * 1.4
   end
   m.vel.x = m.vel.x * hScale
   m.vel.z = m.vel.z * hScale
end

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_mario_action(ACT_MARIO_PUNCH, act_mario_punch)


function mario_on_set_action(m)
  if m.character.type ~= CT_MARIO then return end
  if not movesetactive then return end
	if m.action == ACT_LONG_JUMP then
		m.vel.y = m.vel.y + 3
	elseif m.action == ACT_EMERGE_FROM_PIPE then
		m.vel.y = m.vel.y + 10
    end
	if m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP or m.action == ACT_BACKFLIP or m.action == ACT_SIDE_FLIP or m.action == ACT_WALL_KICK_AIR then
        m.vel.y = m.vel.y + 4
    end
end

function mario_update(m)
  if m.character.type ~= CT_MARIO then return end
  if not movesetactive then return end
	if m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP or m.action == ACT_BACKFLIP or m.action == ACT_SIDE_FLIP or m.action == ACT_DIVE or m.action == ACT_JUMP_KICK or m.action == ACT_BACKWARD_ROLLOUT or m.action == ACT_FORWARD_ROLLOUT or m.action == ACT_WATER_JUMP or m.action == ACT_WALL_KICK_AIR then
        m.vel.y = m.vel.y + 0.4
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_ON_SET_MARIO_ACTION, mario_on_set_action)

function mario_update_local(m)
	local p = gNetworkPlayers[m.playerIndex]
  local np = gNetworkPlayers[m.playerIndex]
    local s  = gPlayerSyncTable[m.playerIndex]

    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    if  m.action == ACT_GROUND_POUND_LAND and gServerSettings.playerInteractions ~= PLAYER_INTERACTIONS_NONE  then
        queue_rumble_data_mario(m, 5, 80)
        play_sound(CHAR_SOUND_MAMA_MIA, m.marioObj.header.gfx.cameraToObject)
        set_mario_action(m, ACT_BUTT_STUCK_IN_GROUND, 0)
    if m.action == ACT_BUTT_STUCK_IN_GROUND then
        m.actionTimer = m.actionTimer + 1
    end

    if  m.action == ACT_BUTT_STUCK_IN_GROUND and m.actionTimer >= 9 then
    set_mario_action(m, ACT_BUTT_SLIDE_STOP, 0)
    end
  end
end
hook_event(HOOK_MARIO_UPDATE, mario_update_local)

function mario_update(m)
  if m.character.type ~= CT_MARIO then return end
  if not movesetactive then return end 
  if m.hurtCounter > e.lastHurtCounter then m.hurtCounter = math.max(3,m.hurtcounter - 4)
  end
end
hook_event(HOOK_MARIO_UPDATE, mario_update)